'use strict';

var Caml_option = require("bs-platform/lib/js/caml_option.js");
var ReasonInk_Style = require("./ReasonInk_Style.bs.js");

function makeRgbProp(color) {
  if (color === undefined) {
    return ;
  }
  if (typeof color === "number") {
    return ;
  }
  if (color[0] !== 5692173) {
    return ;
  }
  var match = color[1];
  return [
          match[0],
          match[1],
          match[2]
        ];
}

function makeHexProp(color) {
  if (color !== undefined && !(typeof color === "number" || color[0] !== 5194459)) {
    return Caml_option.some(color[1]);
  }
  
}

function makeKeywordProp(color) {
  if (color !== undefined) {
    return ReasonInk_Style.Color.toString(color);
  }
  
}

function makeHslProp(color) {
  if (color === undefined) {
    return ;
  }
  if (typeof color === "number") {
    return ;
  }
  if (color[0] !== 5197569) {
    return ;
  }
  var match = color[1];
  return [
          match[0],
          match[1],
          match[2]
        ];
}

function makeHsvProp(color) {
  if (color === undefined) {
    return ;
  }
  if (typeof color === "number") {
    return ;
  }
  if (color[0] !== 5197579) {
    return ;
  }
  var match = color[1];
  return [
          match[0],
          match[1],
          match[2]
        ];
}

function makeHwbProp(color) {
  if (color === undefined) {
    return ;
  }
  if (typeof color === "number") {
    return ;
  }
  if (color[0] !== 5198451) {
    return ;
  }
  var match = color[1];
  return [
          match[0],
          match[1],
          match[2]
        ];
}

function makeAnsiProp(color) {
  if (color !== undefined && !(typeof color === "number" || color[0] !== -1066299709)) {
    return Caml_option.some(color[1]);
  }
  
}

function makeAnsi256Prop(color) {
  if (color !== undefined && !(typeof color === "number" || color[0] !== -1066299709)) {
    return Caml_option.some(color[1]);
  }
  
}

function makeProps(children, fg, bg, param) {
  return {
          children: children,
          rgb: makeRgbProp(fg),
          hex: makeHexProp(fg),
          keyword: makeKeywordProp(fg),
          hsl: makeHslProp(fg),
          hsv: makeHsvProp(fg),
          hwb: makeHwbProp(fg),
          ansi: makeAnsiProp(fg),
          ansi256: makeAnsi256Prop(fg),
          bgRgb: makeRgbProp(bg),
          bgHex: makeHexProp(bg),
          bgKeyword: makeKeywordProp(bg),
          bgHsl: makeHslProp(bg),
          bgHsv: makeHsvProp(bg),
          bgHwb: makeHwbProp(bg),
          bgAnsi: makeAnsiProp(bg),
          bgAnsi256: makeAnsi256Prop(bg)
        };
}

exports.makeProps = makeProps;
/* No side effect */
